#  NACCFC.defn.tcl

proc {NAC CFC} {name c n} {
      define-register $name cCAMAC clear_enable         "-c$c -n$n -a0 -f24"
      define-register $name cCAMAC set_enable        "-c$c -n$n -a0 -f26"
      define-register $name xCAMAC cmd0          "-c$c -n$n -a0 -f0 -prw -l16 -b0 -i0 -zx"
      foreach i {1 2 3 4 5 6 7 8 9  10 11 12 13 14 15} { 
      	define-register $name xCAMAC naf$i          "-c$c -n$n -a$i -f0 -prw -l16 -b0 -i0 -zx"
      }
#      define-register $name cCAMAC disable_multi        "-c$c -n$n -a0 -f24"
#      define-register $name cCAMAC enable_multi         "-c$c -n$n -a0 -f26"
#      define-register $name cCAMAC testtimeout          "-c$c -n$n -a0 -f8 -q1"
      define-register $name cCAMAC reset        "-c$c -n$n -a1 -f24 -q1"
#      define-register $name cCAMAC disable_single       "-c$c -n$n -a1 -f24"
#      define-register $name cCAMAC enable_single        "-c$c -n$n -a1 -f26"
} 

proc {NAC CFC_DAQ-reset} {args} {
#   NACCFC
   set module [first $args]
   if {[read-register $module.reset] != "%01"} then {no-QX $module.clear}
   initialise-register $module.cmd0
   initialise-registers $module.naf?
}

proc {NAC CFC_DAQ-go} {args} {
#   NACCFC
    set module [first $args]
#    read-register $module.clear_enable
#    write-register $module.cmd0 0x8315
#    write-register $module.naf1 0x0202
#    write-register $module.naf2 0x0402
#    write-register $module.naf3 0x0602
    read-register $module.set_enable
}

proc {NAC CFC_DAQ-halt} {args} {
#   NACCFC
    set module [first $args]
    read-register $module.clear_enable
}

#    for camacsaverestore
set {NAC CFC_registersavepatterns} {cmd0 naf1 naf2 naf3 naf4 naf5 naf6 naf7 naf8 naf9 naf10 naf11 naf12 naf13 naf14 naf15}
